﻿Imports System.IO
Imports System.Drawing.Printing

Public Class Form1

    ' File-related variables ...
    Private mstrSalesFileName As String = My.Application.Info.DirectoryPath & "\NWSALES.txt"
    Private mintSalesFileNbr As Short
    Private mblnEOF As Boolean = False

    ' Fields of the input record ...
    Private mstrYearMonth As String
    Private mstrOrderNbr As String
    Private mstrOrderDate As String
    Private mstrCustID As String
    Private mstrProdDesc As String
    Private msngUnitPrice As Single
    Private mintQty As Integer
    Private msngDiscountPct As Single

    ' Printing-related variables...
    Private mobjPrintFont As Font
    Private msngLinesPerPage As Single = 0
    Private msngVerticalPosition As Single = 0
    Private mintLineCount As Integer = 0
    Private mintPageCount As Integer = 0
    Private msngLeftMargin As Single
    Private msngTopMargin As Single

    Private mastrDetailLines() As String
    Private mintLineX As Integer = -1
    Private mintArrX As Integer = 0

    Private Sub btnPrint_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrint.Click

        ' Generate the set of detail lines to be printed ...
        GenerateDetailLineArray()

        ' Declare an object for the PrintDocument class...
        Dim objPrintDocument As PrintDocument = New PrintDocument()

        ' set the orientation to Landscape ...
        objPrintDocument.DefaultPageSettings.Landscape = True

        ' Set the print font...
        mobjPrintFont = New Font("Courier New", 9)

        ' Add an event handler for the PrintPage event of the
        ' objPrintDocument object...
        AddHandler objPrintDocument.PrintPage, AddressOf objPrintDocument_PrintPage

        With PrintPreviewDialog1
            .FindForm().StartPosition = FormStartPosition.CenterScreen
            .Height = 600
            .Width = 800
            .PrintPreviewControl.Zoom = 0.75
            .Document = objPrintDocument
            .ShowDialog()
        End With

    End Sub

    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click

        ' unload the form
        Me.Close()

    End Sub

    Private Sub GenerateDetailLineArray()

        Dim decExtPriceDtl As Decimal
        Dim decDiscAmtDtl As Decimal
        Dim decSaleTotDtl As Decimal

        Dim decExtPriceGrand As Decimal = 0
        Dim decDiscAmtGrand As Decimal = 0
        Dim decSaleTotGrand As Decimal = 0

        mintLineX = -1
        Erase mastrDetailLines
        mblnEOF = False

        ' open the customer data file ...
        mintSalesFileNbr = FreeFile()
        FileOpen(mintSalesFileNbr, mstrSalesFileName, OpenMode.Input)
        ' priming read
        Call ReadSalesRecord()

        ' main outer processing loop
        Do Until mblnEOF

            decExtPriceDtl = msngUnitPrice * mintQty
            decDiscAmtDtl = decExtPriceDtl * msngDiscountPct
            decSaleTotDtl = decExtPriceDtl - decDiscAmtDtl

            ' generate a detail line
            mintLineX += 1
            ReDim Preserve mastrDetailLines(mintLineX)
            mastrDetailLines(mintLineX) = Space(10) _
                                        & mstrOrderDate.PadRight(10) _
                                        & Space(1) _
                                        & mstrOrderNbr.PadRight(5) _
                                        & Space(2) _
                                        & mstrCustID.PadRight(5) _
                                        & Space(3) _
                                        & mstrProdDesc.PadRight(33) _
                                        & Space(1) _
                                        & FormatNumber(msngUnitPrice, 2).PadLeft(6) _
                                        & Space(3) _
                                        & mintQty.ToString.PadLeft(3) _
                                        & Space(2) _
                                        & FormatCurrency(decExtPriceDtl, 2).PadLeft(11) _
                                        & Space(1) _
                                        & FormatCurrency(decDiscAmtDtl, 2).PadLeft(11) _
                                        & Space(1) _
                                        & FormatCurrency(decSaleTotDtl, 2).PadLeft(11)

            ' "roll" the detail amounts to the grand totals
            decExtPriceGrand += decExtPriceDtl
            decDiscAmtGrand += decDiscAmtDtl
            decSaleTotGrand += decSaleTotDtl

            ' read the next record
            Call ReadSalesRecord()

        Loop
        ' end of outer processing loop - time to generate the grand totals

        mintLineX += 1
        ReDim Preserve mastrDetailLines(mintLineX)
        mastrDetailLines(mintLineX) = " "

        mintLineX += 1
        ReDim Preserve mastrDetailLines(mintLineX)
        mastrDetailLines(mintLineX) = Space(70) _
                                    & "GRAND TOTALS:" _
                                    & Space(1) _
                                    & FormatCurrency(decExtPriceGrand, 2).PadLeft(11) _
                                    & Space(1) _
                                    & FormatCurrency(decDiscAmtGrand, 2).PadLeft(11) _
                                    & Space(1) _
                                    & FormatCurrency(decSaleTotGrand, 2).PadLeft(11)

        ' close the input file
        FileClose(mintSalesFileNbr)

    End Sub

     Private Sub objPrintDocument_PrintPage(ByVal sender As Object, _
                                           ByVal e As System.Drawing.Printing.PrintPageEventArgs)

        ' This event fires whenever a new page needs to be printed ...

        Dim blnNewPage As Boolean = True
        Dim strPrintLine As String

        ' line count should be set to zero for a new page            
        mintLineCount = 0

        ' Work out the number of lines per page. Use the MarginBounds
        ' on the event to do this...
        msngLinesPerPage = e.MarginBounds.Height / mobjPrintFont.GetHeight(e.Graphics)
        ' set the left and top margins ...
        msngLeftMargin = e.MarginBounds.Left
        msngTopMargin = e.MarginBounds.Top

        ' print the report headings
        PrintHeadings(e)

        ' Process detail records as long as there is room on the page and
        ' the last entry of the array has not been reached ...
        While (mintLineCount < msngLinesPerPage And mintArrX <= UBound(mastrDetailLines))
            strPrintLine = mastrDetailLines(mintArrX)
            If blnNewPage Then
                 blnNewPage = False
            Else
                ' handle group indication (suppress order date, order #, and customer ID if same as previous)
                If mintArrX > 0 Then
                    If Mid(mastrDetailLines(mintArrX), 11, 23) = Mid(mastrDetailLines(mintArrX - 1), 11, 23) Then
                        Mid(strPrintLine, 11, 23) = Space(23)
                    End If
                End If
            End If
            ' print the detail line
            PrintReportLine(strPrintLine, e)
            mintArrX += 1
        End While

        If mintArrX <= UBound(mastrDetailLines) Then
            e.HasMorePages = True
        Else
            mintPageCount = 0
            mintArrX = 0
            e.HasMorePages = False
        End If

    End Sub

    Private Sub PrintHeadings(ByVal e As System.Drawing.Printing.PrintPageEventArgs)

        Dim strLine As String

        mintPageCount = mintPageCount + 1

        strLine = "Print Date: " _
                & Format(Today, "MM/dd/yy") _
                & Space(28) _
                & "THEVBPROGRAMMER.COM" _
                & Space(41) _
                & "Page: " _
                & CStr(mintPageCount).PadLeft(3)
        PrintReportLine(strLine, e)

        strLine = "Print Time: " _
                & Format(TimeOfDay, "hh:mm:ss") _
                & Space(24) _
                & "NORTHWIND TRADERS SALES REPORT"
        PrintReportLine(strLine, e)

        strLine = Space(39) _
                & "WITH NO CONTROL BREAKS (GRAND TOTALS ONLY)"
        PrintReportLine(strLine, e)

        PrintReportLine(" ", e)

        strLine = Space(21) _
                & "ORDER  CUST" _
                & Space(38) _
                & "UNIT" _
                & Space(12) _
                & "EXTENDED    DISCOUNT"
        PrintReportLine(strLine, e)

        strLine = Space(10) _
                & "ORDER DATE " _
                & "NUMBER  ID    PRODUCT DESCRIPTION" _
                & Space(16) _
                & "PRICE   QTY" _
                & Space(6) _
                & "PRICE       AMOUNT   SALE TOTAL"
        PrintReportLine(strLine, e)

        strLine = Space(10) _
                & "---------- " _
                & "------  --    -------------------" _
                & Space(16) _
                & "-----   ---" _
                & Space(6) _
                & "-----       ------   ----------"
        PrintReportLine(strLine, e)

        PrintReportLine(" ", e)

    End Sub

    Private Sub PrintReportLine(ByVal pstrLine As String, _
                                ByVal e As System.Drawing.Printing.PrintPageEventArgs)

        Dim objPrintFont As Font
        Dim blnMakeLineBold As Boolean

        ' Calculate the vertical position on the page...
        msngVerticalPosition = msngTopMargin _
                             + (mintLineCount * mobjPrintFont.GetHeight(e.Graphics))

        If pstrLine.ToUpper.Contains("TOTALS") Then
            blnMakeLineBold = True
        ElseIf IsMonthHeader(pstrLine) Then
            blnMakeLineBold = True
        Else
            blnMakeLineBold = False
        End If

        If blnMakeLineBold Then
            objPrintFont = New Font("Courier New", 9, System.Drawing.FontStyle.Bold)
        Else
            objPrintFont = New Font("Courier New", 9)
        End If

        ' Pass the string to be printed to DrawString ... 
        e.Graphics.DrawString(pstrLine, _
                              objPrintFont, _
                              Brushes.Black, _
                              msngLeftMargin, _
                              msngVerticalPosition, _
                              New StringFormat())

        ' Increment the line count...
        mintLineCount += 1

    End Sub

    Private Sub ReadSalesRecord()

        If EOF(mintSalesFileNbr) Then
            mblnEOF = True
        Else
            Input(mintSalesFileNbr, mstrYearMonth)
            Input(mintSalesFileNbr, mstrOrderDate)
            Input(mintSalesFileNbr, mstrOrderNbr)
            Input(mintSalesFileNbr, mstrCustID)
            Input(mintSalesFileNbr, mstrProdDesc)
            Input(mintSalesFileNbr, msngUnitPrice)
            Input(mintSalesFileNbr, mintQty)
            Input(mintSalesFileNbr, msngDiscountPct)
        End If

    End Sub

    Private Function IsMonthHeader(ByVal pstrTestLine As String) As Boolean

        For intX = 1 To 12
            If Trim(pstrTestLine).ToUpper.StartsWith(MonthName(intX).ToUpper) Then
                Return True
            End If
        Next

        Return False

    End Function

End Class
